/**********************************************
* Zeus CMD - OpenGL ES Tutorial 19 : Blending *
* By Grant James (ZEUS)                       *
* http://www.zeuscmd.com                      *
**********************************************/
#pragma comment(lib, "libGLES_CM.lib")

#define GLUTES_STATIC

#include <GLES/glutes.h>

GLfloat rectangle[] = {
	-1.0f, -0.25f,
	 1.0f, -0.25f,
	-1.0f,  0.25f,
	 1.0f,  0.25f
};

int currBlend = 4;

GLenum blendSrc[] = {
	GL_ONE,
	GL_ONE,
	GL_ONE,
	GL_SRC_ALPHA,
	GL_SRC_ALPHA
};

GLenum blendDst[] = {
	GL_ZERO,
	GL_ONE,
	GL_ONE_MINUS_DST_ALPHA,
	GL_ONE,
	GL_ONE_MINUS_SRC_ALPHA
};

void init()
{
	glClearColor (0.25f, 0.25f, 0.25f, 1.0f);

	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
}

void display()
{
	glClear (GL_COLOR_BUFFER_BIT);
	glLoadIdentity();

	glVertexPointer(2, GL_FLOAT, 0, rectangle);

	glEnableClientState(GL_VERTEX_ARRAY);

	glPushMatrix();
		glTranslatef(1.5f, 2.0f, 0.0f);
		glColor4f(1.0f, 0.0f, 0.0f, 0.5f);
		glDrawArrays(GL_TRIANGLE_STRIP, 0, 4);
	glPopMatrix();

	glPushMatrix();
		glTranslatef(0.7f, 1.5f, 0.0f);
		glRotatef(90.0f, 0.0f ,0.0f, 1.0f);
		glColor4f(0.0f, 1.0f, 0.0f, 0.5f);
		glDrawArrays(GL_TRIANGLE_STRIP, 0, 4);
	glPopMatrix();

	glPushMatrix();
		glTranslatef(1.7f, 1.5f, 0.0f);
		glRotatef(90.0f, 0.0f ,0.0f, 1.0f);
		glColor4f(0.0f, 0.0f, 1.0f, 0.25f);
		glDrawArrays(GL_TRIANGLE_STRIP, 0, 4);
	glPopMatrix();

	glPushMatrix();
		glTranslatef(1.5f, 1.0f, 0.0f);
		glColor4f(1.0f, 1.0f, 0.0f, 0.75f);
		glDrawArrays(GL_TRIANGLE_STRIP, 0, 4);
	glPopMatrix();

	glFlush ();
	glutSwapBuffers();
}

void keyboard2(int key, int x, int y)
{
	switch(key)
	{
	case GLUT_KEY_UP : exit(0); break;
	}
}

void reshape(int width, int height)
{
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();

	glViewport(0, 0, width, height);
	glOrthof(0.0f, 3.0f, 0.0f, 3.0f, -1.0f, 1.0f);

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
}

void menu(int entry)
{
	switch(entry)
	{
	case 1 : exit(0); break;
	case 2 :
		++currBlend %= 5;
		glBlendFunc(blendSrc[currBlend], blendDst[currBlend]);
		glutPostRedisplay();
		break;
	}
}

int main(int argc, char *argv[])
{
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGBA);

	glutCreateWindow("19 - Blending");

	init();

	glutDisplayFunc(display);
	glutReshapeFunc(reshape);
	glutSpecialFunc(keyboard2);

	glutCreateMenu(menu);
	glutAddMenuEntry("Blending Function", 2);
	glutAddMenuEntry("Quit", 1);

	glutAttachMenu(GLUT_LEFT_BUTTON);
	
	glutMainLoop();

	return 0;
}
